interface Fruit {
    seed(): Fruit;
}

abstract class Vegetable {
    abstract seed(): Vegetable;
}

abstract class Flower_vegetable extends Vegetable {
    constructor(private readonly _color: string = "green") {
        super();
    }
}

abstract class Fruit_vegetable extends Vegetable implements Fruit {
    constructor(private readonly _color: string = "red") {
        super();
    }
}

class Broccoli extends Flower_vegetable {
    seed(): Broccoli {
        return new Broccoli();
    }
}

class Tomato extends Fruit_vegetable {
    seed(): Tomato {
        return new Tomato();
    }
}

class Soup_recipe<V extends Vegetable = Broccoli> {
    private readonly _soup: Set<V> = new Set();

    public add(v: V) {
        this._soup.add(v);
    }
}

const s: Soup_recipe<Tomato> = new Soup_recipe;
// s.add(new Broccoli); // Compilation error...
s.add(new Tomato);

const s_ = new Soup_recipe; // Inferred type is 'Soup_recipe<Broccoli>'
// s_.add(new Tomato); // Compilation error...
